mod classfile;
mod classstore;
mod bytecode;
mod jvm;
mod stackframe;
mod accessmasks;
mod constantpool;
mod heap_area;
mod iterators;
mod native_registry;
mod native_methods;

//use std::fs::File;
//
//use crate::accessmasks::FieldAccessFlag;
//use crate::stackframe::StackValue;
//use crate::classfile::JavaClassFile;
use std::path::PathBuf;

fn main() {
    //println!("{:#?}", JavaClassFile::new(&mut File::open("java/lang/System.class").unwrap()).unwrap());

    let mut jvm = jvm::JVM::new();
    jvm.class_store.class_path_fragments.push(PathBuf::from("./classpath"));

    match jvm.entrypoint(
        &"Main".to_string(), 
        &"main".to_string(),
        &["Hello World"],
    ) {
        Ok(()) => (),
        Err(e) => println!("{:#?}", e),
    }

    match jvm.run() {
        Ok(()) => (),
        Err(e) => println!("{:#?}", e),
    };

    //println!("{:#?}", jvm.heap_area.static_area);
}
